Get Manual Activity Sheet Dependencies
GET /ws/rest/service/v2/activity/sheet/dependencies?project_number={project_number}&activity_sheet_type={activity_sheet_type}&source_project_id={source_project_id}&project_type={project_type}&activity_sheet_name={activity_sheet_name}
Available: 25.10 and later
Purpose
Retrieve dependencies data of an activity from an activity sheet in a specified Unifier project/shell.
Prerequisites
Ensure the following:
- A sourceProjectId (the projectId of the external application configured from Oracle Primavera Cloud) already exists for the system activity sheet.
- An activity sheet for the manual activity sheet exists.
- An activity sheet that has activities with dependencies exists
- To get dependencies for externally synced or manual activity sheets from another application, configure or add the source project ID or manual activity sheets as follows:
- Select the project/shell and switch to Admin mode.
- From the Dashboard menu in the top-right corner, select Details.
- In the Details page, select the Primavera Cloud Integration tab for a system sheet activity.
Request Format
Send a GET request in the format specified above.
Query Parameters
The following parameters can be specified in the request:
| Request Parameter | Required? | Data Type | Description |
|---|---|---|---|
| project_number | Yes | String | A valid project/shell with an Active status to get Assignments data of Activities |
| activity_sheet_type | Yes | String | Valid choices include: "manual" and "system". |
| activity_sheet_name | Yes, only if activity_sheet_type is "manual". | String | The name of the activity sheet. |
| source_project_id | No | String | The project code in Oracle Primavera Cloud. |
| project_type | No | String | Current/Baseline project types are allowed for fetching the activities created in corresponding sheets. Valid values include: (Default) "Current" and "Baseline". |
Response Format
A JSON object is returned in the following format:
{
"data": [],
"message": [<list of messages>],
"status": <REST status code value>,
"rest_audit_id": <id from the audit table>
}
A successful response displays a status code 200.
A failed response displays a message with a status code.
Sample Success Request
To retrieve activity sheet dependencies, send a request in the following format:
{hostUrl}//ws/rest/service/v2/activity/sheet/dependencies?project_number=P-0115&project_type=Current&activitySheetType=manual&activity_sheet_name=ManualSheet
Sample Success Response
A successful response with status code 200 displays in the following format:
{
"data": [
{
"pred_activityid": "A1020",
"succ_activityid": "A1010",
"relation":"Finish-to-Start",
"lead_lag": 10
},
{
"pred_activityid": "A1040",
"succ_activityid": "A1030",
"relation":"Finish-to-Start",
"lead_lag": 10
}
],
"message": ["success"],
"rest_audit_id": 24630,
"status": 200
}
Sample Request for No Dependency
To retrieve an activity sheet with no dependencies, send a request in the following format:
{hostUrl}/ws/rest/service/v2/activity/sheet/dependencies?project_number=P-0115&activity_sheet_name=ActAPIBug&activity_sheet_type=system&project_type=Current
Sample Response for No Dependency
A successful response with status code 200 displays in the following format:
{
"data": [],
"message": ["success"],
"rest_audit_id": 24886,
"status": 200
}
Sample Failure Request
A request in the following format fails to retrieve activity sheet dependencies:
{hostUrl}//ws/rest/service/v2/activity/sheet/dependencies?project_number=P-0115&project_type=Current&activitySheetType=manual&activity_sheet_name=
Sample Failure Response
A failed response to retrieve activity dependencies displays the corresponding status code in the following format:
{
"data": [],
"message": [
"The API request contains empty value for: [activity_sheet_name]. If the activity_sheet_type=manual, then activity_sheet_name cannot be empty."
],
"status": 12068,
"rest_audit_id": 18721
}
Supported Validation Messages and Status Codes
The following validation messages and status codes display in the response when incorrect values are provided in the request:
| Field Name | Use-case Scenario | Status Code | Error Message |
|---|---|---|---|
| project_number | project_number is not specified. | 12018 | The project number field is empty. Enter a valid project number. |
| project_number | project_number is empty. | 12128 | The project number field is empty. Enter a valid project number. |
| project_number | project_number is invalid or null. | 602 | Project/Shell Number is not correct. |
| project_number | project_number is inactive. | 12020 | The project number [project_number] is currently inactive or on-hold . Verify its status in Unifier before proceeding. |
| activity_sheet_type | activity_sheet_type is missing in the request. | 12010 | The API request is missing the required information: [activitySheetType] |
| activity_sheet_type | activity_sheet_type is invalid. | 12011 | Invalid value was found in a field: [activitySheetType]. Allowed values: [manual, system] |
| activity_sheet_type | activity_sheet_type is null or empty. | 12034 | The API request contains an empty value for: [activitySheetType]. Allowed values: [manual, system] |
| activity_sheet_name | If the sheet type is manual, activity_sheet_name is missing in the request. | 12012 | Activity sheet name [activity_sheet_name] is missing from the request. |
| activity_sheet_name | activity_sheet_name is empty for activity sheet type "manual". | 12068 | Activity sheet name cannot be empty. If the activity_sheet_type=manual, then activity_sheet_name cannot be empty. |
| activity_sheet_name | activity_sheet_name exceeds 50 characters. | 12017 | Invalid value was found in a field: [activity_sheet_name]. Allowed length: [250] |
| activity_sheet_name | activity_sheet_name does not exist. | 12013 | Activity sheet name, [activity_sheet_name] does not exist as a manual sheet in Unifier. Check if this name has been configured as a manual sheet in Unifier. |
| source_project_id | source_project_id is not configured in the source unifier shell | 12021 | The API request contains an invalid value: [sourceProjectId]. Please check if this sourceProjectId has been configured in Unifier. |
| source_project_id | source_project_id has invalid special characters. | 12022 | The API request contains invalid characters in: [source_project_id]. The following characters are not allowed : / \\ : * ? \" < > | ' = |
| source_project_id | source_project_id is missing if activity sheet Type is "system". | 12005 | The API request is missing the required information: [sourceProjectId] |
| source_project_id | source_project_id exceeds 250 characters. | 12014 | Invalid value was found in a field: [activitySheetName]. Allowed length: [250] |
| source_project_id | source_project_id is empty/blank or null. | 12032 | The API request contains empty value for: [sourceProjectId]. |
| source_project_id | source project id integrated with P6 has been passed | 12019 | Project IDs from P6 are not supported. Use a project ID from Primavera Cloud or a Manual Sheet to receive data. |
| project_type | project_type is null or empty. | 12144 | The API request contains empty value for: [projectType]. Allowed values: [Current, Baseline] |
| project_type | project_type value is invalid. | 12145 | Invalid value was found in a field: 'projectType'. Allowed values: [Current, Baseline] |
| project_type | Baseline sheet is not configured. | 12036 | Invalid value was found in a field: [projectType]. Baseline not defined for this Project. |